using System.Drawing;
using System.Windows.Forms;


namespace Spire.DataExport.Wizard
{
    public enum WizardButtons
    {
        None,
        OK,
        Cancel,
        OKCancel,
        NextCancel,
        BackNextCancel,
        BackFinishCancel,
    }

    public partial class BaseWizardForm : Form
    {
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.backCommonButton = new System.Windows.Forms.Button();
            this.nextCommonButton = new System.Windows.Forms.Button();
            this.cancelCommonButton = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // backCommonButton
            // 
            this.backCommonButton.DialogResult = System.Windows.Forms.DialogResult.Retry;
            this.backCommonButton.Location = new System.Drawing.Point(194, 338);
            this.backCommonButton.Name = "backCommonButton";
            this.backCommonButton.Size = new System.Drawing.Size(80, 23);
            this.backCommonButton.TabIndex = 3;
            this.backCommonButton.Text = "Back";
            this.backCommonButton.UseVisualStyleBackColor = true;
            this.backCommonButton.Click += new System.EventHandler(this.backCommonButton_Click);
            // 
            // nextCommonButton
            // 
            this.nextCommonButton.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.nextCommonButton.Location = new System.Drawing.Point(284, 338);
            this.nextCommonButton.Name = "nextCommonButton";
            this.nextCommonButton.Size = new System.Drawing.Size(80, 23);
            this.nextCommonButton.TabIndex = 4;
            this.nextCommonButton.Text = "Next";
            this.nextCommonButton.UseVisualStyleBackColor = true;
            this.nextCommonButton.Click += new System.EventHandler(this.nextCommonButton_Click);
            // 
            // cancelCommonButton
            // 
            this.cancelCommonButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.cancelCommonButton.Location = new System.Drawing.Point(374, 338);
            this.cancelCommonButton.Name = "cancelCommonButton";
            this.cancelCommonButton.Size = new System.Drawing.Size(80, 23);
            this.cancelCommonButton.TabIndex = 5;
            this.cancelCommonButton.Text = "Cancel";
            this.cancelCommonButton.UseVisualStyleBackColor = true;
            this.cancelCommonButton.Click += new System.EventHandler(this.cancelCommonButton_Click);
            // 
            // BaseWizardForm
            // 
            this.AcceptButton = this.nextCommonButton;
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.None;
            this.CancelButton = this.cancelCommonButton;
            this.ClientSize = new System.Drawing.Size(514, 427);
            this.Controls.Add(this.cancelCommonButton);
            this.Controls.Add(this.nextCommonButton);
            this.Controls.Add(this.backCommonButton);
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "BaseWizardForm";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "BaseWizardForm";
            this.ResumeLayout(false);

        }

        #endregion

        protected Button backCommonButton;
        protected Button nextCommonButton;
        protected Button cancelCommonButton;


        ////////////////////////////////////////////////////////////////////////////////////////
        protected WizardButtons formButtons = WizardButtons.OKCancel;

        public WizardButtons WizardButton
        {
            get { return this.formButtons; }
            set
            {
                this.formButtons = value;
                this.ChangeFormButtons(value);
            }
        }

        public BaseWizardForm()
        {
            InitializeComponent();
        }

        protected override void OnCreateControl()
        {
            base.OnCreateControl();

            this.AutoScaleMode = AutoScaleMode.None;
        }

        private void ChangeFormButtons(WizardButtons buttons)
        {
            this.RePositionButtons();

            switch (buttons)
            {
                case WizardButtons.None:
                    {
                        this.backCommonButton.Visible = false;
                        this.nextCommonButton.Visible = false;
                        this.cancelCommonButton.Visible = false;
                    }
                    break;
                case WizardButtons.OK:
                    {
                        this.nextCommonButton.Text = "OK";
                        this.nextCommonButton.Location = this.cancelCommonButton.Location;

                        this.backCommonButton.Visible = false;
                        this.cancelCommonButton.Visible = false;
                        this.nextCommonButton.Visible = true;
                    }
                    break;
                case WizardButtons.Cancel:
                    {
                        this.cancelCommonButton.Text = "Cancel";

                        this.backCommonButton.Visible = false;
                        this.nextCommonButton.Visible = false;
                        this.cancelCommonButton.Visible = true;
                    }
                    break;
                case WizardButtons.OKCancel:
                    {
                        this.nextCommonButton.Text = "OK";
                        this.cancelCommonButton.Text = "Cancel";

                        this.backCommonButton.Visible = false;
                        this.cancelCommonButton.Visible = true;
                        this.nextCommonButton.Visible = true;
                    }
                    break;
                case WizardButtons.NextCancel:
                    {
                        this.nextCommonButton.Text = "Next";
                        this.cancelCommonButton.Text = "Cancel";

                        this.backCommonButton.Visible = false;
                        this.cancelCommonButton.Visible = true;
                        this.nextCommonButton.Visible = true;
                    }
                    break;
                case WizardButtons.BackNextCancel:
                    {
                        this.backCommonButton.Text = "Back";
                        this.nextCommonButton.Text = "Next";
                        this.cancelCommonButton.Text = "Cancel";

                        this.backCommonButton.Visible = true;
                        this.cancelCommonButton.Visible = true;
                        this.nextCommonButton.Visible = true;
                    }
                    break;
                case WizardButtons.BackFinishCancel:
                    {
                        this.backCommonButton.Text = "Back";
                        this.nextCommonButton.Text = "Finish";
                        this.cancelCommonButton.Text = "Cancel";

                        this.backCommonButton.Visible = true;
                        this.cancelCommonButton.Visible = true;
                        this.nextCommonButton.Visible = true;
                    }
                    break;
            }
        }

        private void RePositionButtons()
        {
            this.cancelCommonButton.Location = new Point(this.ClientRectangle.Width - this.cancelCommonButton.Width - 10, this.ClientRectangle.Height - this.cancelCommonButton.Height - 10);
            this.nextCommonButton.Location = new Point(this.cancelCommonButton.Left - this.nextCommonButton.Width - 15, this.ClientRectangle.Height - this.nextCommonButton.Height - 10);
            this.backCommonButton.Location = new Point(this.nextCommonButton.Left - this.backCommonButton.Width - 15, this.ClientRectangle.Height - this.backCommonButton.Height - 10);

            this.cancelCommonButton.Visible = true;
            this.backCommonButton.Visible = true;
            this.nextCommonButton.Visible = true;
        }

        protected override void OnSizeChanged(System.EventArgs e)
        {
            base.OnSizeChanged(e);

            if (this.cancelCommonButton == null)
                return;

            this.ChangeFormButtons(this.formButtons);
        }

        private void backCommonButton_Click(object sender, System.EventArgs e)
        {
            if (!this.OnBack())
                this.DialogResult = DialogResult.None;
        }

        private void nextCommonButton_Click(object sender, System.EventArgs e)
        {
            if (this.WizardButton == WizardButtons.BackFinishCancel)
            {
                if (!this.OnFinish())
                    this.DialogResult = DialogResult.None;
            }
            else
            {
                if (!this.OnNext())
                    this.DialogResult = DialogResult.None;
            }
        }

        private void cancelCommonButton_Click(object sender, System.EventArgs e)
        {
            if (!this.OnCancel())
                this.DialogResult = DialogResult.None;
        }

        protected virtual bool OnBack()
        {
            return true;
        }

        protected virtual bool OnNext()
        {
            return true;
        }

        protected virtual bool OnFinish()
        {
            return true;
        }

        protected virtual bool OnCancel()
        {
            return true;
        }

        private WizardController wizardContainer;
        public WizardController WizardContainer
        {
            get
            {
                return this.wizardContainer;
            }
            set
            {
                this.wizardContainer = value;
            }
        }
    }
}
