using System;
using System.Data;
using System.Text;
using Spire.DataExport.Wizard.Steps;

namespace Spire.DataExport.Wizard
{
    class DataExportWizardController : WizardController
    {
        public DataExportWizardController()
        {
            this.Context = new DataExportWizardContext();

            this.AddForm(typeof(ChooseDatabase));
            this.AddForm(typeof(ChooseDataSource));
            this.AddForm(typeof(ChooseColumns));
            this.AddForm(typeof(ChooseResultFormat));
        }
    }

    public class DataExportWizardContext
    {
        private String dbProviderFacotoryName;
        private String dbConnectionString;
        private String tableName;
        private String sqlCommand;
        private DataTable columns;
        private String fileType;
        private String fileName;

        public String DbProviderFacotoryName
        {
            get
            {
                return this.dbProviderFacotoryName;
            }
            set
            {
                this.dbProviderFacotoryName = value;
            }
        }

        public String DbConnectionString
        {
            get
            {
                return this.dbConnectionString;
            }
            set
            {
                this.dbConnectionString = value;
            }
        }

        public String TableName
        {
            get
            {
                return this.tableName;
            }
            set
            {
                this.tableName = value;
            }
        }

        public String SQLCommand
        {
            get
            {
                return this.sqlCommand;
            }
            set
            {
                this.sqlCommand = value;
            }
        }

        public DataTable Columns
        {
            get
            {
                return this.columns;
            }
            set
            {
                this.columns = value;
            }
        }

        public String FileType
        {
            get
            {
                return this.fileType;
            }
            set
            {
                this.fileType = value;
            }
        }

        public String FileName
        {
            get
            {
                return this.fileName;
            }
            set
            {
                this.fileName = value;
            }
        }

        public String BuildSQL()
        {
            if (this.sqlCommand != null && this.sqlCommand.Length > 0)
            {
                return this.sqlCommand;
            }
            StringBuilder columnList = new StringBuilder();

            foreach (DataRow columnMeta in columns.Rows)
            {
                if (Convert.ToBoolean(columnMeta["ColumnSelected"]))
                {
                    if (columnList.Length > 0)
                    {
                        columnList.Append(", ");
                    }
                    columnList.Append(columnMeta["ColumnName"]);
                }
            }

            return String.Format(" SELECT {0} FROM {1} ", columnList, this.tableName);
        }

        public Spire.DataExport.Collections.StringListCollection SelectedColumns
        {
            get
            {
                Spire.DataExport.Collections.StringListCollection columns
                    = new Spire.DataExport.Collections.StringListCollection();
                foreach (DataRow columnMeta in this.columns.Rows)
                {
                    if (Convert.ToBoolean(columnMeta["ColumnSelected"]))
                    {
                        columns.Add(columnMeta["ColumnName"]);
                    }
                }

                return columns;
            }
        }
    }
}
